<template>
  <div>
    <div class="page-title">
      <h3>{{ 'New record' | localization }}</h3>
    </div>

    <Loader v-if="loading" />

    <p v-else-if="!categories.length" class="center">
     {{ 'No categories yet' | localization }}
      <router-link to="/categories">
        {{ 'Add new category' | localization }}
      </router-link>
    </p>

    <form v-else class="form" @submit.prevent="submitHandler">
      <div class="input-field" >
        <select ref="select" v-model="id">
          <option
            v-for="category in categories"
            :key="category.id"
            :value="category.id"
          >
            {{ category.name }}
          </option>
        </select>
        <label>{{ 'Select category' | localization }}</label>
      </div>

      <p>
        <label>
          <input
              class="with-gap"
              name="type"
              type="radio"
              value="income"
              v-model="type"
          />
          <span>{{ 'Income' | localization }}</span>
        </label>
      </p>

      <p>
        <label>
          <input
              class="with-gap"
              name="type"
              type="radio"
              value="outcome"
              v-model="type"
          />
          <span>{{ 'Outcome' | localization }}</span>
        </label>
      </p>

      <div class="input-field">
        <input
            id="amount"
            type="number"
            v-model.number="amount"
            :class="{invalid: ($v.amount.$dirty && !$v.amount.required) || ($v.amount.$dirty && !$v.amount.maxValue)}"
        >
        <label for="amount">{{ 'Amount' | localization }}</label>

        <span v-if="$v.amount.$dirty && !$v.amount.required" class="helper-text invalid">
          {{ 'Enter amount' | localization }}
        </span>

        <span v-if="$v.amount.$dirty && !$v.amount.maxValue" class="helper-text invalid">
          {{ 'Amount cannot be more than' | localization }} {{ limit }}
        </span>

      </div>

      <div class="input-field">
        <input
            id="description"
            type="text"
            v-model="description"
            :class="{invalid: $v.description.$dirty && !$v.description.required}"
        >
        <label for="description">{{ 'Description' | localization }}</label>

        <span v-if="$v.description.$dirty && !$v.description.required" class="helper-text invalid">
          {{ 'Enter description' | localization }}
        </span>

      </div>

      <button class="btn waves-effect waves-light" type="submit">
        {{ 'Create' | localization }}
        <i class="material-icons right">send</i>
      </button>
    </form>
  </div>
</template>

<script>
  import {required, maxValue} from 'vuelidate/lib/validators';
  import localization from "@/filters/localization";

  export default {
    name: "Record",
    data: () => ({
      select: null,
      loading: true,
      categories: [],
      id: null,
      limit: null,
      type: 'income',
      amount: null,
      description: ''
    }),
    computed: {
      userInfo() {
        return this.$store.getters.getUserInfo;
      },
      canCreateRecord() {
        if (this.type === 'income') {
          return true;
        }

        return this.amount <= this.userInfo.bill;
      }
    },
    validations() {
      return {
        amount: {
          required,
          maxValue: 'outcome' === this.type ? maxValue(this.limit) : false
        },
        description: {
          required
        }
      };
    },
    async mounted() {
      this.categories = await this.$store.dispatch('getCategories');
      this.loading = false;

      if (!this.categories.length) {
        return;
      }

      this.id = this.categories[0].id;
      this.limit = this.categories[0].limit

      setTimeout(() => {
        this.select = M.FormSelect.init(document.querySelector('select'));
      }, 0);

    },
    watch: {
      id(value) {
        const idx = this.categories.findIndex(c => c.id === value);
        this.limit = this.categories[idx].limit
      },
      limit(value) {
        this.$v.amount.$params.maxValue = value;
      }
    },
    methods: {
      async submitHandler() {
        if (this.$v.$invalid) {
          this.$v.$touch();
          return;
        }

        if (!this.canCreateRecord) {
          this.$message(localization('Insufficient funds'));

          return;
        }

        try {

          const formData = {
            categoryId: this.id,
            type: this.type,
            amount: this.amount,
            description: this.description,
            date: new Date().toJSON()
          };

          await this.$store.dispatch('saveRecord', formData);

          this.userInfo.bill += 'income' === this.type ? this.amount : - this.amount;

          await this.$store.dispatch('updateInfo', {bill: this.userInfo.bill});

          this.$v.$reset();

          this.id = this.categories[0].id;
          this.type = 'income';
          this.amount = '';
          this.description = '';

          this.$message(localization('Record added'));

          setTimeout(() => {
            M.updateTextFields();
            this.select = M.FormSelect.init(document.querySelector('select'));
          }, 0);

        } catch (e) {
          console.log(e);
        }

      }
    },
    beforeDestroy() {
      if (this.select && this.select.destroy) {
        this.select.destroy();
      }
    }
  }
</script>

<style scoped>

</style>